#include "bogie.h"
#include "vehicle.h"
#include "vehicletype.h"

using namespace Msp;

namespace R2C2 {

Bogie3D::Bogie3D(const Vehicle3D &v, unsigned b):
	VehiclePart3D(v, *v.get_type().get_bogie_object(b)),
	bogie(vehicle.get_vehicle().get_bogie(b))
{ }

void Bogie3D::update_matrix()
{
	matrix = vehicle.Object3D::get_matrix();

	matrix.translate(bogie.type->position, 0, 0);
	Angle dir = bogie.direction;
	if(bogie.type->rotate_object)
		dir += Angle::half_turn();
	matrix.rotate(dir, 0, 0, 1);
}

} // namespace R2C2
