#ifndef DEPARTURESDIALOG_H_
#define DEPARTURESDIALOG_H_

#include <msp/gltk/dropdown.h>
#include <msp/gltk/label.h>
#include "libr2c2/departures.h"
#include "dynamicdialog.h"

class Engineer;

class DeparturesDialog: public DynamicDialog
{
public:
	class StateLoader: public Msp::DataFile::DerivedObjectLoader<DeparturesDialog, DynamicDialog::StateLoader>
	{
	public:
		StateLoader(DeparturesDialog &);

	private:
		void group(const std::string &);
	};

private:
	struct Row
	{
		const R2C2::Departures::Departure *departure;
		Msp::GLtk::Label *lbl_time;
		Msp::GLtk::Label *lbl_train;

		Row();

		void set_departure(const R2C2::Departures::Departure *);
	};

	const R2C2::Layout &layout;
	Msp::GLtk::Dropdown *drp_groups;
	Msp::GLtk::Label *lbl_title;
	Msp::GLtk::BasicListData<std::string> groups;
	Msp::GLtk::Panel *pnl_departures;
	R2C2::Departures *departures;
	std::vector<Row> rows;

public:
	DeparturesDialog(Engineer &, const std::string & = std::string());

	void set_group(const std::string &);

private:
	void group_selected(unsigned);
	void update_rows();

public:
	virtual bool save_state(Msp::DataFile::Statement &) const;
};

#endif
